// C Source File
// Created 26/08/01; 12:04:42

#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization

#define SAVE_SCREEN           // Save/Restore LCD Contents

#include <tigcclib.h>         // Include All Header Files
#include <crystal_IO.h>         

short _ti89,_ti92plus;                  // Produce .89Z File

//////////////////////////////////////////////////////////////////
// Dclaration des variables utilisables dans tout le programme //
//////////////////////////////////////////////////////////////////

////Fonctions (pout viter l'erreur "implicit declaration"////
void DrwScrAct(void);
void SetLevelEntities(int level);
void DrawPortals(void);
int CreateBullet(int x, int y, int Vx, int Vy);
int RectCollisions(int x1, int y1, int l1, int h1, int x2, int y2, int l2, int h2);
void EntCollisions(void);
int OpenGate(void);
void KbdTraduct(int speed);
void intro(void);
void DrwBullet(int timer);
void DrwScrAct(void);
void FillWithZeros(void);

////Ecran Virtuels////
	void *VScrEntities;

////Variables////
	int x,y,Vx,Vy,a,run,opened;
	int level, NbCrystal;


////Matrices////
	int MBullet[6][5];
	int MEntities[2][3][25];
	int MEnnemies[5][5][5];

////Sprites////

	static unsigned char bullet[]=
		{0x60, 0xF0, 0xF0, 0x60};
	static unsigned char Balle[]=
		{0x18, 0x66, 0x66, 0x99, 0x99, 0x66, 0x66, 0x18};
	static unsigned char Crystal[]=
		{0x18, 0x3C, 0x5A, 0xFF, 0xFF, 0x5A, 0x3C, 0x18};
	static unsigned char Mine[]=
		{ 0x99, 0x5A, 0x24, 0xDB, 0xDB, 0x24, 0x5A, 0x99};
	static unsigned char LeftGate[]=
		{ 0x3, 0xE, 0x3E, 0x39, 0x74, 0x72, 0xC9, 0xA4};
	static unsigned char MidGate[]=
		{ 0xFF, 0x0, 0xFF, 0x0, 0x0, 0xFF, 0x18, 0x7E};
	static unsigned char RightGate[]=
		{ 0x80, 0x70, 0xBC, 0x3C, 0x5E, 0x96, 0x26, 0x49};
	static unsigned char Erase8[]=
		{ 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0};

///////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////
////                                                                                       ////
////								 ------------------------------------------------------------					 ////
////               / |Prparation d'un niveau et routines de dplacement | /               ////
////			   -------------------------------------------------------------								 ////
////																																											 ////
///////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////
// Disposition alatoire des crystaux et obstacles //
/////////////////////////////////////////////////////
void SetLevelEntities(int level){
	int Rx, Ry,t;

PortSet(VScrEntities,LCD_HEIGHT-1,LCD_WIDTH-1); // Permet de dessiner sur l'cran virtuel 

	for(a=0;a<level+10;a++){
		lbl_rand:
		for(t=0;t<100;t++){
			Rx=random(152);
			Ry=random(92);	// Position alatoire
		}
	
	for(t=0;t<level+10;t++) 
		if(RectCollisions(Rx,Ry,8,8,MEntities[0][1][t],MEntities[0][2][t],8,8)) goto lbl_rand;
	
	if(RectCollisions(Rx,Ry,8,8,64,92,8,8) 
			| 
		RectCollisions(Rx,Ry,8,8,88,92,8,8)
			| 
		RectCollisions(Rx,Ry,8,8,72,92,16,8)) goto lbl_rand;

//======================================================|
// MEntities[type][infos][n] :													|
//	-type : 0 pour les crystaux, 1 pour les mines				|
//	-infos : 0 pour l'affichage, 1 pour Rx, 2 pour Ry		|
//	-n : ligne contenant toutes les infos de l'entit	|
//																											|
//	Ex : MEntities[0][0][12]=1 veut dire que le Crystal	|
//		(type=0) n12 [n=12] sera affich 								|
//		([0][infos=0][12]=1).															|
//=======================================================
	MEntities[0][0][a]=1;
	MEntities[0][1][a]=Rx;
	MEntities[0][2][a]=Ry;
	Sprite8(Rx,Ry,8,Crystal,VScrEntities,SPRT_XOR); // Dessine un crystal sur l'cran virtuel
	}
	
	for(a=0;a<level+5;a++){
		lbl_rand2:
		for(t=0;t<100;t++){
			Rx=random(152);
			Ry=random(92);	// Position alatoire
		}
	
	for(t=0;t<level+10;t++) 
		if(RectCollisions(Rx,Ry,8,8,MEntities[0][1][t],MEntities[0][2][t],8,8)) goto lbl_rand2;
	for(t=0;t<level+10;t++) 
		if(RectCollisions(Rx,Ry,8,8,MEntities[1][1][t],MEntities[1][2][t],8,8)) goto lbl_rand2;
		
	if(RectCollisions(72,42,16,16,Rx,Ry,8,8)) goto lbl_rand2;
	
	if(RectCollisions(Rx,Ry,8,8,64,92,8,8) 
			| 
		RectCollisions(Rx,Ry,8,8,88,92,8,8)
			| 
		RectCollisions(Rx,Ry,8,8,72,92,16,8)) goto lbl_rand;

//======================================================|
// MEntities[type][infos][n] :													|
//	-type : 0 pour les crystaux, 1 pour les mines				|
//	-infos : 0 pour l'affichage, 1 pour Rx, 2 pour Ry		|
//	-n : ligne contenant toutes les infos de l'entit	|
//																											|
//	Ex : MEntities[0][0][12]=1 veut dire que le Crystal	|
//		(type=0) n12 [n=12] sera affich 								|
//		([0][infos=0][12]=1).															|
//=======================================================
	MEntities[1][0][a]=1;
	MEntities[1][1][a]=Rx;
	MEntities[1][2][a]=Ry;
	Sprite8(Rx,Ry,8,Mine,VScrEntities,SPRT_XOR); // Dessine un crystal sur l'cran virtuel
	}
	
PortRestore(); // Dsactive le mode de dessin sur cran virtuel
}


/////////////////////////////////////////////////////
//          Disposition des 3 portails             //
/////////////////////////////////////////////////////
void DrawPortals(void){
	
PortSet(VScrEntities,LCD_HEIGHT-1,LCD_WIDTH-1);
	Sprite8(64,92,8,LeftGate,VScrEntities,SPRT_XOR);
	Sprite8(72,92,8,MidGate,VScrEntities,SPRT_XOR);
	Sprite8(80,92,8,MidGate,VScrEntities,SPRT_XOR);
	Sprite8(88,92,8,RightGate,VScrEntities,SPRT_XOR);
PortRestore();
}

///////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////
////                                                                                       ////
////											 -------------------------------------------------							 ////
////                     / |Interprtation des actions utilisateur | /                     ////
////				    	---------------------------------------------------											 ////
////																																											 ////
///////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////


/////////////////////////////////////////////////////////////////////////
//     Cr une nouvelle balle de position x,y ; de vitesse Vx,Vy ;    //
/////////////////////////////////////////////////////////////////////////
int CreateBullet(int x, int y, int Vx, int Vy){
int i;

	if((Vx==0)&(Vy==0))return 0;  
		for(i=0;i<6;i++){
			if(MBullet[i][0]==0){
				MBullet[i][0]=1;MBullet[i][1]=x;MBullet[i][2]=y;MBullet[i][3]=Vx;MBullet[i][4]=Vy;
				return 1;
			}
		}

return 0;

}

/////////////////////////////////////////////////////////////////////////
//     Collision basique entre deux objets supposs rectangulaires     //
//					Retourne 1 s'il y a collision, 0 en cas contraire					 //
/////////////////////////////////////////////////////////////////////////
int RectCollisions(int x1, int y1, int l1, int h1, int x2, int y2, int l2, int h2){	
	if((x1>x2-l1) & (x1<x2+l2)){
		if((y1>y2-h1) & (y1<y2+h2)){
			return 1;
		}
	}
	return 0;
}

/////////////////////////////////////////////////////////////////////////
//  						Gre les collisions entre hros et crystaux            //
/////////////////////////////////////////////////////////////////////////
void EntCollisions(void){

PortSet(VScrEntities,LCD_HEIGHT-1,LCD_WIDTH-1); // Permet de dessiner sur l'cran virtuel 

	for(a=0;a<=level+10;a++){
		if(MEntities[0][0][a]){
		if(RectCollisions(x,y,8,8,MEntities[0][1][a],MEntities[0][2][a],8,8)){
			NbCrystal++;
			MEntities[0][0][a]=0;
			Sprite8(MEntities[0][1][a],MEntities[0][2][a],8,Crystal,VScrEntities,SPRT_XOR); 
			// Efface le crystal sur l'cran virtuel	

		}	
		}
	}
	
PortRestore(); // Dsactive le mode de dessin sur cran virtuel

	for(a=0;a<level+5;a++) 
	if(RectCollisions(x,y,8,8,MEntities[1][1][a],MEntities[1][2][a],8,8)) run=0;
	
	if(RectCollisions(x,y,8,8,64,92,8,8)) run=0;
	if(RectCollisions(x,y,8,8,88,92,8,8)) run=0;
	if(RectCollisions(x,y,8,8,72,92,16,8) & (NbCrystal<=level+11)) run=0;
}

/////////////////////////////////////////////////////////////////////////
//  						Cr un nouvel ennemi, selon le niveau etc.            //
/////////////////////////////////////////////////////////////////////////


/////////////////////////////////////////////////////////////////////////
//  		Ouverture de la grille quand tous les crystaux sont pris       //
/////////////////////////////////////////////////////////////////////////
int OpenGate(void){
int a,b;

	if(!opened){
		
		PortSet(VScrEntities,LCD_HEIGHT-1,LCD_WIDTH-1);
			Sprite8(72,92,8,Erase8,VScrEntities,SPRT_AND);
			Sprite8(72,92,8,Erase8,VScrEntities,SPRT_OR);
			Sprite8(80,92,8,Erase8,VScrEntities,SPRT_AND);
			Sprite8(80,92,8,Erase8,VScrEntities,SPRT_OR);
		PortRestore();

		opened=1;
		
	}
	
	if(RectCollisions(x,y,8,8,70,92,18,10)){
		x=76;
		y=88;
		PortSet(VScrEntities,LCD_HEIGHT-1,LCD_WIDTH-1);
			for(a=0;a<30;a++){
				y++;
				for(b=0;b<20000;b++);
				DrwScrAct();
			}
		PortRestore();
		
		return 0;
		
	}
	
	return 1;
}


/////////////////////////////////////////////////////////////////////////
//  Interprtation des touches appuyes (lecture par KbdRead())        //
/////////////////////////////////////////////////////////////////////////
void KbdTraduct(int speed){

		switch(KbdRead(speed)){
		case 0:
			if(Vx>0)Vx--;
			if(Vx<0)Vx++;
			if(Vy>0)Vy--;
			if(Vy<0)Vy++;
			break;/* aucune touche n'est enfonce ;
						vrifie si la balle doit avoir une
						inertie, et, dans ce cas, ralentit
						petit  petit la balle */

		case 337:Vy-=5;break;//augmente la vitesse verticale vers le haut
		case 338:Vx-=5;break;//augmente la vitesse horizontale vers la gauche
		case 340:Vy+=5;break;//augmente la vitesse verticale vers le bas
		case 344:Vx+=5;break;//augmente la vitesse horizontale vers la droite

		case 2:CreateBullet(x+2,y+2,Vx,Vy);
			if(Vx>0)Vx--;
			if(Vx<0)Vx++;
			if(Vy>0)Vy--;
			if(Vy<0)Vy++;
			break;//2nd, tire une balle  la vitesse de l'objet  l'instant

		case 266:run=0;break;//home ; quitte la boucle
	}	
	x+=Vx;y+=Vy;
	if(x<0)x=0;if(y<0)y=0;if(x>152)x=152;if(y>92)y=92;
	if(Vx>10)Vx=10;if(Vy>10)Vy=10;if(Vx<-10)Vx=-10;if(Vy<-10)Vy=-10;
}


///////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////
////                                                                                       ////
////																	------------------------------											 ////
////                                / |GESTION DE L'AFFICHAGE | /                          ////
////														 ------------------------------    												 ////
////																																											 ////
///////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////
//                      Introduction dans le jeu                        //
//////////////////////////////////////////////////////////////////////////
void intro(void){
clrscr();
FontSetSys(F_8x10);
	DrawStr(30,20,"CrYsTaL",A_NORMAL);
	DrawStr(50,40,"QUEST.",A_NORMAL);
FontSetSys(F_6x8);
	DrawStr(10,60,"By ced38,",A_NORMAL);
	DrawStr(30,70,"ced38@ifrance.com",A_NORMAL);
FontSetSys(F_4x6);
	DrawStr(10,5,"Last Addition : Mines",A_NORMAL);
	DrawStr(80,94,"Version BETA n0.05",A_NORMAL);
	while(!KbdRead(100));
}

//////////////////////////////////////////////////////////////////////////
// DESSINE les balles  l'cran, et vrifie si elle sortent de celui-ci //
//////////////////////////////////////////////////////////////////////////
void DrwBullet(int timer){
int j,k;
	for(j=0;j<=5;j++){
	
		for(k=0;k<timer;k++);
	
		if(MBullet[j][0]==1){
			MBullet[j][1]+=MBullet[j][3];
			MBullet[j][2]+=MBullet[j][4];
			Sprite8(MBullet[j][1],MBullet[j][2],4,bullet,LCD_MEM,SPRT_XOR);
		
			if((MBullet[j][1]>=160) | (MBullet[j][2]>=100) | ((MBullet[j][1] | MBullet[j][2])<=0)){
				MBullet[j][0]=0;
			}
	
		}
	
	}
}

/////////////////////////////////////////////////
// Affichage final (ce que vois l'utilisateur) //
/////////////////////////////////////////////////
void DrwScrAct(void){
	clrscr();
	LCD_restore(VScrEntities);
	Sprite8(x,y,8,Balle,LCD_MEM,SPRT_XOR);
	DrwBullet(1000);
}

////////////////////////////////////////////////////////////////////////////
// Dsactivation des crans virtuels, nv de gris, etc., pour ne pas avoir //
// d'erreurs en revenant sur le TI-OS                                     //
////////////////////////////////////////////////////////////////////////////
void FillWithZeros(void){
	
	memset(MBullet,0,sizeof(MBullet));						// Rempli la matrice des balles de 0 (elles
																								// s'affichent donc pas et on peut en crer)
																								
	memset(MEntities,0,sizeof(MEntities));				// Rempli la matrice des Mines et crystaux de 0
																								// (ne s'affichent donc pas et on peut en crer)
																								
  memset(VScrEntities,0,LCD_SIZE);   						// On libre l'espace mmoire qui avait t 
  																							// allou pour l'cran virtuel.
  memset(LCD_MEM,0,LCD_SIZE);   								// Rinitialise l'cran.
  																							
}

///////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////



// Main Function
void _main(void)
{
Disable_int();						// Fonction de crystal_IO.h

x=76, y=46;								//===========================================//
Vx=0, Vy=0;								// Donne les valeurs initiales des variables //
a=1,run=1,opened=0; 	  	//===========================================//
NbCrystal=0;
VScrEntities=malloc(LCD_SIZE); // On alloue un espace de la taille de l'cran  l'cran virtuel

FillWithZeros();					// Rempli les matrices de Zros (par ex., efface les crans virtuels)
SetLevelEntities(1);			// Initialise les objets d'un niveau (en argument, le numro du niveau)
DrawPortals();						// Dessine les portails
intro();

while(run){
	KbdTraduct(150);						// Reoit et interprte les actions clavier
	EntCollisions();
	DrwScrAct();								// Dessine l'crans dans l'tat actuel
	if(NbCrystal==level+11){
		if(!OpenGate()) run=0;
	}
}

FillWithZeros();					// Rempli les matrices de Zros (par ex., efface les crans virtuels)
free(VScrEntities);				// Libre l'cran virtuel
Reenable_int();						// Fonction de crystal_IO.h
}
