// C Source File
// Created 26/08/01; 12:04:42

#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization

#define SAVE_SCREEN           // Save/Restore LCD Contents


#include <tigcclib.h>         // Include All Header Files
#include "crystal_sys.h"         
#include "img.h"         
#include "rowkeys.h"         


short _ti89,_ti92plus;                  // Produce .89Z File

//////////////////////////////////////////////////////////////////
// Dclaration des variables utilisables dans tout le programme //
//////////////////////////////////////////////////////////////////

////Fonctions (pout viter l'erreur "implicit declaration")////
int  CreateBullet(int t, int x, int y, int Vx, int Vy);
void DrawBullets(void);
void DrawPortals(void *Scr);
void DrawScrAct(void);
void FillVScreen(void *VScr,short color);
void FillWithZeros(void);
void end(int error);
void EMouvDiag(int type, int num, int Ex, int Ey, int EVx, int EVy, int bounce);
void EMouvDogs(int type, int num, int Ex, int Ey, int V);
void EMouvLine(int type, int num, int Ex, int Ey, int EVx, int EVy, int freq);
void EMouvRand(int type, int num, int Ex, int Ey);
void EntCollisions(void);
void ExtraLife(void);
void GameInfo(void);
void intro(void);
void KbdTraduct(void);
void KillAll(void);
void LoopLevel(void);
void lost(char *msg);
int  OpenGate(void);
int  RectCollisions(int x1, int y1, int l1, int h1, int x2, int y2, int l2, int h2);
int  SetEnnemies(void);
void SetLevelEntities(int level);
void SpriteAnim2(int type, int num, unsigned char *img1, unsigned char *img2, int tps);
void RunLevel(void);
void win(void);


////Ecran Virtuels////
	void *VScrEntities;
	void *VBackUp;

////Variables  portes globales////
	char *LastAdd;
	char *Todo;
	char *Version;
	int x,y,Vx,Vy,opened;
	int NumEnnemies;
	int OldTime, Time, level, NbCrystals, NbMines, NbLives, NbKills, NbBombs;
	int EnnemyTimer;


////Listes & Matrices////
	int Score[2];
	char *MsgLost;
	int MBullet[15][10][5];
	int MEntities[3][3][25];
	int MEnnemies[15][5][8];/*[x][y][z] :
																			-z=0 : affiche l'ennemi (1) ou pas (0)
																			-z=1 et 2 : respectivement x et y
																			-z=3 et 4 : respectivement Vx et Vy
																			-z=5 : vie de l'ennemi
																			-z=6 : force des balles
																			-z=7 : compteur pour savoir quel tape de l'animation
													*/

///////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////
////                                                                                       ////
////								 ------------------------------------------------------------					 ////
////               / | Prparation, lancement et droulement d'un niveau | /               ////
////			   -------------------------------------------------------------								 ////
////																																											 ////
///////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////
// Disposition alatoire des crystaux et obstacles //
/////////////////////////////////////////////////////
void SetLevelEntities(int level){
	int Rx, Ry,b,c;

	NbCrystals=(level/2)+9;
		if(NbCrystals>25) NbCrystals=25;
	
	NbMines=level-4;
		if(level==1)NbMines=0;
		if((level>1) & (level<5)) NbMines=3;
		if((level>=5) & (level<10)) NbMines=5;
		if(NbMines>10) NbMines=10;	
	
		if(level<5) NbBombs=0;
		if((level>=5) & (level<10)) NbBombs=3;
		if(level>=10) NbBombs=5;
		
PortSet(VScrEntities,239,127); // Permet de dessiner sur l'cran virtuel 

	for(b=0;b<NbCrystals;b++){
		lbl_rand:
		for(c=0;c<100;c++){
			Rx=random(LCD_WIDTH-8);
			Ry=random(LCD_HEIGHT-8);	// Position alatoire
		}
	
	for(c=0;c<NbCrystals;c++) 
		if(RectCollisions(Rx,Ry,8,8,MEntities[0][1][c],MEntities[0][2][c],8,8)) goto lbl_rand;
	
	if(RectCollisions(Rx,Ry,8,8,64,LCD_HEIGHT-8,8,8) 
			| 
		RectCollisions(Rx,Ry,8,8,88,LCD_HEIGHT-8,8,8)
			| 
		RectCollisions(Rx,Ry,8,8,72,LCD_HEIGHT-8,16,8)
			| 
		RectCollisions(Rx,Ry,8,8,0,38,8,24)
			| 
		RectCollisions(Rx,Ry,8,8,LCD_WIDTH-8,38,8,24)) goto lbl_rand;

//======================================================|
// MEntities[type][infos][n] :													|
//	-type : 0 pour les crystaux, 1 pour les mines				|
//	-infos : 0 pour l'affichage, 1 pour Rx, 2 pour Ry		|
//	-n : ligne contenant toutes les infos de l'entit	|
//																											|
//	Ex : MEntities[0][0][12]=1 veut dire que le Crystal	|
//		(type=0) n12 [n=12] sera affich 								|
//		([0][infos=0][12]=1).															|
//=======================================================
	MEntities[0][0][b]=1;
	MEntities[0][1][b]=Rx;
	MEntities[0][2][b]=Ry;
	Sprite8(Rx,Ry,8,Crystal,VScrEntities,SPRT_XOR); // Dessine un crystal sur l'cran virtuel
	}
	
	for(b=0;b<NbMines;b++){
		lbl_rand2:
		for(c=0;c<100;c++){
			Rx=random(LCD_WIDTH-8);
			Ry=random(LCD_HEIGHT-8);	// Position alatoire
		}
	
	for(c=0;c<NbCrystals;c++) 
		if(RectCollisions(Rx,Ry,8,8,MEntities[0][1][c],MEntities[0][2][c],8,8)) goto lbl_rand2;
	for(c=0;c<NbMines;c++) 
		if(RectCollisions(Rx,Ry,8,8,MEntities[1][1][c],MEntities[1][2][c],8,8)) goto lbl_rand2;
		
	if(RectCollisions(72,42,16,16,Rx,Ry,8,8)) goto lbl_rand2;
	
	if(RectCollisions(Rx,Ry,8,8,64,LCD_HEIGHT-8,8,8) 
			| 
		RectCollisions(Rx,Ry,8,8,88,LCD_HEIGHT-8,8,8)
			| 
		RectCollisions(Rx,Ry,8,8,72,LCD_HEIGHT-8,16,8)
			| 
		RectCollisions(Rx,Ry,8,8,0,38,8,24)
			| 
		RectCollisions(Rx,Ry,8,8,LCD_WIDTH-8,38,8,24)) goto lbl_rand2;
		
//======================================================|
// MEntities[type][infos][n] :													|
//	-type : 0 pour les crystaux, 1 pour les mines				|
//	-infos : 0 pour l'affichage, 1 pour Rx, 2 pour Ry		|
//	-n : ligne contenant toutes les infos de l'entit	|
//																											|
//	Ex : MEntities[0][0][12]=1 veut dire que le Crystal	|
//		(type=0) n12 [n=12] sera affich 								|
//		([0][infos=0][12]=1).															|
//=======================================================
	MEntities[1][0][b]=1;
	MEntities[1][1][b]=Rx;
	MEntities[1][2][b]=Ry;
	Sprite8(Rx,Ry,8,Mine,VScrEntities,SPRT_XOR); // Dessine un crystal sur l'cran virtuel
	}
	
	for(b=0;b<NbBombs;b++){
		lbl_rand3:
		for(c=0;c<100;c++){
			Rx=random(LCD_WIDTH-8);
			Ry=random(LCD_HEIGHT-8);	// Position alatoire
		}
	
	for(c=0;c<NbCrystals;c++) 
		if(RectCollisions(Rx,Ry,7,8,MEntities[0][1][c],MEntities[0][2][c],8,8)) goto lbl_rand3;
	for(c=0;c<NbMines;c++) 
		if(RectCollisions(Rx,Ry,7,8,MEntities[1][1][c],MEntities[1][2][c],8,8)) goto lbl_rand3;
	for(c=0;c<NbBombs;c++) 
		if(RectCollisions(Rx,Ry,7,8,MEntities[2][1][c],MEntities[2][2][c],7,8)) goto lbl_rand3;
		
	if(RectCollisions(72,42,16,16,Rx,Ry,7,8)) goto lbl_rand3;
	
	if(RectCollisions(Rx,Ry,7,8,64,LCD_HEIGHT-8,8,8) 
			| 
		RectCollisions(Rx,Ry,7,8,88,LCD_HEIGHT-8,8,8)
			| 
		RectCollisions(Rx,Ry,7,8,72,LCD_HEIGHT-8,16,8)
			| 
		RectCollisions(Rx,Ry,8,8,0,38,8,24)
			| 
		RectCollisions(Rx,Ry,8,8,LCD_WIDTH-8,38,8,24)) goto lbl_rand3;
		
//======================================================|
// MEntities[type][infos][n] :													|
//	-type : 0 pour les crystaux, 1 pour les mines				|
//	-infos : 0 pour l'affichage, 1 pour Rx, 2 pour Ry		|
//	-n : ligne contenant toutes les infos de l'entit	|
//																											|
//	Ex : MEntities[0][0][12]=1 veut dire que le Crystal	|
//		(type=0) n12 [n=12] sera affich 								|
//		([0][infos=0][12]=1).															|
//=======================================================
	MEntities[2][0][b]=1;
	MEntities[2][1][b]=Rx;
	MEntities[2][2][b]=Ry;
	Sprite8(Rx,Ry,8,Bomb,VScrEntities,SPRT_XOR); // Dessine un crystal sur l'cran virtuel
	}
	NbBombs+=3;
	
PortRestore(); // Dsactive le mode de dessin sur cran virtuel
}


/////////////////////////////////////////////////////
//          Disposition des 3 portails             //
/////////////////////////////////////////////////////
void DrawPortals(void *VScr){
	
PortSet(VScr,239,127);
	Sprite8((LCD_WIDTH/2)-16,LCD_HEIGHT-8,8,LeftGate,VScrEntities,SPRT_XOR);
	Sprite8((LCD_WIDTH/2)-8,LCD_HEIGHT-8,8,MidGate,VScrEntities,SPRT_XOR);
	Sprite8((LCD_WIDTH/2),LCD_HEIGHT-8,8,MidGate,VScrEntities,SPRT_XOR);
	Sprite8((LCD_WIDTH/2)+8,LCD_HEIGHT-8,8,RightGate,VScrEntities,SPRT_XOR);
	Sprite8(0,38,8,UpLeftBase,VScrEntities,SPRT_XOR);
	Sprite8(0,54,8,DownLeftBase,VScrEntities,SPRT_XOR);
	Sprite8(LCD_WIDTH-8,38,8,UpRightBase,VScrEntities,SPRT_XOR);
	Sprite8(LCD_WIDTH-8,54,8,DownRightBase,VScrEntities,SPRT_XOR);
PortRestore();
}

/////////////////////////////////////////////////////
//         Routine qui rempli un cran             //
//             d'une couleur unie                  //
/////////////////////////////////////////////////////
void FillVScreen(void *VScr,short color){
	int c;
	
	PortSet(VScr,239,127);
	
	if(color){
		for(c=0;c<LCD_HEIGHT;c++) DrawLine(0,c,LCD_WIDTH,c,color);
	}
	else{
		for(c=0;c<LCD_HEIGHT;c++) DrawLine(0,c,LCD_WIDTH,c,color);
	}
	
	PortRestore();
}


/////////////////////////////////////////////////////
//          Lance le niveau et appelle             //
//             la boucle continuelle               //
/////////////////////////////////////////////////////
void RunLevel(void){
	FillWithZeros();					// Rempli les matrices de Zros (par ex., efface les crans virtuels)
	SetLevelEntities(level);			// Initialise les objets d'un niveau (en argument, le numro du niveau)
	DrawPortals(VScrEntities);						// Dessine les portails
	LoopLevel();
}

/////////////////////////////////////////////////////
//          Boucle continuelle tant que            //
//           le niveau n'est pas fini              //
/////////////////////////////////////////////////////
void LoopLevel(void){
	do{
		DrawScrAct();								// Dessine l'crans dans l'tat actuel
		WaitForMillis(80);
		Time++;
		KbdTraduct();						// Reoit et interprte les actions clavier
		if(!NbCrystals){
				if(!OpenGate()) win();
		}
		EntCollisions();
		SetEnnemies();
	}while(TRUE);
}

/////////////////////////////////////////////////////
//     Lorsque le joueur passe le portail          //
/////////////////////////////////////////////////////
void win(void){
int c;
	Score[0]=NbLives;
	clrscr();
	for(c=0;c<(Time/10);c++){
		printf_xy(10,10,"%s","Temps : ");
		printf_xy(40,10,"%s","                          ");
		printf_xy(40,10,"%d",c*10);
	}
	if(((221+(level*50)-Time))>0){
			printf_xy(10,20,"%s","BONUS : ");		
		for(c=0;c<((220+(level*50)-Time))/10;c++){
			Score[1]+=10;
			printf_xy(10,30,"%s","Score : ");
			printf_xy(40,30,"%s","                          ");
			printf_xy(40,30,"%d",Score[1]);
		}
	}
	else{
			printf_xy(10,20,"%s","Trop de temps, pas de Bonus ! <:(");
			printf_xy(10,30,"%s","Score : ");
			printf_xy(40,30,"%d",Score[1]);
	}
	printf_xy(10,40,"%s","Nombre de vies : ");
	printf_xy(70,40,"%d",Score[0]);
	if(!CALCULATOR){
		WAITKEYPRESSED(_89_KEY_ENTER);
	} 
	else{
		WAITKEYPRESSED(_92P_KEY_ENTER1);
	}

	level++;
	x=(LCD_WIDTH/2)-4; 
	y=(LCD_HEIGHT/2)-4;				//===========================================//
	Vx=0, Vy=0;								// Donne les valeurs initiales des variables //
	opened=0; 	  						//===========================================//
	Time=0;
	EnnemyTimer=0;
	
	RunLevel();
}

/////////////////////////////////////////////////////
//       Lorsque le joueur perd une vie            //
/////////////////////////////////////////////////////
void lost(char *msg){
int c;
	MsgLost=msg;
	LCD_restore(VScrEntities);
	for(c=0;c<=6;c++){
		WaitForMillis(200);
		Sprite8(x,y,8,Balle,LCD_MEM,SPRT_XOR);
	}
	if(!NbLives) end(0);
	else{
		NbLives--;
		x=(LCD_WIDTH/2)-4;
		y=(LCD_HEIGHT/2)-4;
		Vx=0;
		Vy=0;
		memset(MEnnemies,0,sizeof(MEnnemies));			// Rempli la matrice des Ennemis de 0
																								// (ne s'affichent donc pas et on peut en crer)
		memset(MBullet,0,sizeof(MBullet));			// Rempli la matrice des Ennemis de 0
																								// (ne s'affichent donc pas et on peut en crer)

	}
}


/////////////////////////////////////////////////////
//           Affichage des informations            //
//						sur la partie en cours               //
/////////////////////////////////////////////////////
void GameInfo(void){
GrayOn();
	SetPlane(DARK_PLANE);
	clrscr();
		FontSetSys(F_8x10);
	printf_xy(60,10,"%s","PAUSE");
	DrawLine(60,22,100,22,A_NORMAL);
	DrawLine(60,23,100,23,A_NORMAL);
		FontSetSys(F_6x8);
	printf_xy(1,30,"%s","Informations sur la partie");
	DrawLine(1,40,158,40,A_NORMAL);
		FontSetSys(F_4x6);
	printf_xy(10,50,"%s","Score : ");
	printf_xy(40,50,"%d",Score[1]);
	printf_xy(10,60,"%s","Vies : ");
	printf_xy(40,60,"%d",NbLives);
	printf_xy(10,70,"%s","Bombes : ");
	printf_xy(40,70,"%d",NbBombs);
	printf_xy(60,50,"%s","Cause de la dernire mort : ");
	printf_xy(60,60,"%s",MsgLost);

	SetPlane(LIGHT_PLANE);
	clrscr();
		FontSetSys(F_8x10);
	printf_xy(60,10,"%s","PAUSE");
	DrawLine(60,22,100,22,A_NORMAL);
	DrawLine(60,23,100,23,A_NORMAL);
		FontSetSys(F_6x8);
	printf_xy(1,30,"%s","Informations sur la partie");
	DrawLine(1,40,158,40,A_NORMAL);
		FontSetSys(F_4x6);
	printf_xy(70,90,"%s","Press [ENTER]");
	if(!CALCULATOR){
		WAITKEYPRESSED(_89_KEY_ENTER);
	} 
	else{
		WAITKEYPRESSED(_92P_KEY_ENTER1);
	}

GrayOff();

}

///////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////
////                                                                                       ////
////											 -------------------------------------------------							 ////
////                     / |Interprtation des actions utilisateur | /                     ////
////				    	---------------------------------------------------											 ////
////																																											 ////
///////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////


/////////////////////////////////////////////////////////////////////////
//     Cr une nouvelle balle de position x,y ; de vitesse Vx,Vy ;    //
/////////////////////////////////////////////////////////////////////////
int CreateBullet(int t, int x, int y, int Vx, int Vy){
int c;

	if((Vx==0)&(Vy==0))return 0;  
		for(c=0;c<10;c++){
			if(!MBullet[t][c][0]){
				MBullet[t][c][0]=1;
				MBullet[t][c][1]=x;
				MBullet[t][c][2]=y;
				MBullet[t][c][3]=Vx;
				MBullet[t][c][4]=Vy;
				return 1;
			}
		}

return 0;

}

//////////////////////////////////////////////////////////////////////////
// DESSINE les balles  l'cran, et vrifie si elle sortent de celui-ci //
//////////////////////////////////////////////////////////////////////////
void DrawBullets(void){
int c,j;

	for(c=0;c<15;c++){
	for(j=0;j<10;j++){

		MBullet[c][j][1]+=MBullet[c][j][3];
		MBullet[c][j][2]+=MBullet[c][j][4];
		if(	(MBullet[c][j][1]>=LCD_WIDTH-8)
		 			|
		 		(MBullet[c][j][2]>=LCD_HEIGHT-8)
		 			|
		 		((MBullet[c][j][1] | MBullet[c][j][2])<=0)){
			MBullet[c][j][0]=0;
		}

		if(MBullet[c][j][0]){
			if(c==0) Sprite8(MBullet[c][j][1],MBullet[c][j][2],4,Bullet,LCD_MEM,SPRT_XOR);
			if(c==1) Sprite8(MBullet[c][j][1],MBullet[c][j][2],4,EBullet1,LCD_MEM,SPRT_XOR);
			if(c==2) Sprite8(MBullet[c][j][1],MBullet[c][j][2],4,EBullet2,LCD_MEM,SPRT_XOR);
		}

	}
	}
}

/////////////////////////////////////////////////////////////////////////
//     Collision basique entre deux objets supposs rectangulaires     //
//					Retourne 1 s'il y a collision, 0 en cas contraire					 //
/////////////////////////////////////////////////////////////////////////
int RectCollisions(int x1, int y1, int l1, int h1, int x2, int y2, int l2, int h2){	
	if((x1>x2-l1) & (x1<x2+l2)){
		if((y1>y2-h1) & (y1<y2+h2)){
			return 1;
		}
	}
	return 0;
}

/////////////////////////////////////////////////////////////////////////
//  						Gre les collisions entre Hros et Crystaux            //
//  						  "   "      "        "   Hros et Objets              //
//  						  "   "      "        "   Hros et Mchants            //
//  						  "   "      "        "   Balles et Mchants           //
/////////////////////////////////////////////////////////////////////////
void EntCollisions(void){
int b,c,d;

PortSet(VScrEntities,239,127); // Permet de dessiner sur l'cran virtuel 

	for(c=0;c<25;c++){
		if(MEntities[0][0][c]){
			if((MEntities[0][0][c]) & (RectCollisions(x,y,8,8,MEntities[0][1][c],MEntities[0][2][c],8,8))){
				NbCrystals--;
//				Score[1]+=100;
				MEntities[0][0][c]=0;
				Sprite8(MEntities[0][1][c],MEntities[0][2][c],8,Crystal,VScrEntities,SPRT_XOR); 
				// Efface le crystal sur l'cran virtuel	
			}	
		}
	
			if((MEntities[1][0][c]) & (RectCollisions(x,y,8,8,MEntities[1][1][c],MEntities[1][2][c],8,8))){
				NbMines--;
				MEntities[1][0][c]=0;
				PortRestore();
				lost("Ennemi");
				PortSet(VScrEntities,239,127);
				Sprite8(MEntities[1][1][c],MEntities[1][2][c],8,Mine,VScrEntities,SPRT_XOR); 
				// Efface la mine sur l'cran virtuel	
			}	

			if((MEntities[2][0][c]) & (RectCollisions(x,y,8,8,MEntities[2][1][c],MEntities[2][2][c],7,8))){
				NbBombs++;	
				MEntities[2][0][c]=0;
				Sprite8(MEntities[2][1][c],MEntities[2][2][c],8,Bomb,VScrEntities,SPRT_XOR); 
				// Efface la bombe sur l'cran virtuel	
			}	
	}
	
	for(b=1;b<15;b++){
	for(c=0;c<10;c++){
		if((MBullet[b][c][0]) & (RectCollisions(x,y,8,8,MBullet[b][c][1],MBullet[b][c][2],4,4))){
				PortRestore();
				lost("Balle ennemie");
			}
	}
	}
	
	for(b=0;b<10;b++){
		for(c=0;c<5;c++){
		for(d=0;d<15;d++){
			if((MEnnemies[d][c][0])
					&
				(RectCollisions(MEnnemies[d][c][1],MEnnemies[d][c][2],8,8,MBullet[0][b][1],MBullet[0][b][2],4,4))){
				MBullet[0][b][0]=0;
				if(!MEnnemies[d][c][5]) MEnnemies[d][c][0]=0;
				else MEnnemies[d][c][5]--;
//				Score[1]+=1000*(1+d);
			}		
			if((MEnnemies[d][c][0]) & (RectCollisions(x,y,8,8,MEnnemies[d][c][1],MEnnemies[d][c][2],8,8))){
				PortRestore();
				lost("Ennemi");
			}
		}
		}
	}
	
PortRestore(); // Dsactive le mode de dessin sur cran virtuel
	
	if(RectCollisions(x,y,8,8,(LCD_WIDTH/2)-16,LCD_HEIGHT-8,8,8)
			|
		RectCollisions(x,y,8,8,(LCD_WIDTH/2)+8,LCD_HEIGHT-8,8,8)
			|
		RectCollisions(x,y,8,8,0,38,8,24)
			| 
		RectCollisions(x,y,8,8,LCD_WIDTH-8,38,8,24)){
			PortRestore();
			lost("base ennemie");
		}
		
	if(RectCollisions(x,y,8,8,(LCD_WIDTH/2)-8,LCD_HEIGHT-8,16,8) & (!opened)){
		PortRestore();
		lost("portail");
	}
}

/////////////////////////////////////////////////////////////////////////
//  						Cr un nouvel ennemi, selon le niveau etc.            //
/////////////////////////////////////////////////////////////////////////
int SetEnnemies(void){
int c,b,R;
	b=0;
	R=random(2);
	
	if(level==1) return 0;

	if(Time==(EnnemyTimer+20)){
		EnnemyTimer+=50;		

		for(c=0;c<5;c++){
			if(level%2)
				b=random(level/2);
			else
				b=(level/2)-1;

			if(!MEnnemies[b][c][0]){
	
				MEnnemies[b][c][0]=1;
				MEnnemies[b][c][7]=0;
			
			if(R) MEnnemies[b][c][1]=0;
			else MEnnemies[b][c][1]=LCD_WIDTH-8;
			
			MEnnemies[b][c][2]=44;
			MEnnemies[b][c][3]=random(11)-4;
			if(!MEnnemies[b][c][3]) 
				MEnnemies[b][c][3]++;

			if(b!=2){			
				MEnnemies[b][c][4]=random(11)-4;
				if(!MEnnemies[b][c][4]) MEnnemies[b][c][4]++;
			}	
			else{
				MEnnemies[b][c][4]=0;			
				MEnnemies[b][c][5]=2;			
			}		
				return 1;
			}
			
		}
	}
	return 0;
}

/////////////////////////////////////////////////////////////////////////
//  					    	Dessine tous les ennemis sur l'cran               //
/////////////////////////////////////////////////////////////////////////
void DrawEnnemies(void){
int b,c,R;

	Sprite8(x,y,8,Balle,LCD_MEM,SPRT_XOR);	//-> premirement, dessine le hros (sur l'cran principal)	

	for(b=0;b<15;b++){
	for(c=0;c<5;c++){
		if((MEnnemies[b][c][0])&(b==0)){//Mchant du dbut
			EMouvRand(b,c,1,2);

			if(MEnnemies[b][c][7]<=3){
				Sprite8(MEnnemies[b][c][1],MEnnemies[b][c][2],8,Mechant11,LCD_MEM,SPRT_XOR);
			}
			if((MEnnemies[b][c][7]>3) & (MEnnemies[b][c][7]<=6)){
				Sprite8(MEnnemies[b][c][1],MEnnemies[b][c][2],8,Mechant12,LCD_MEM,SPRT_XOR);				
			}
			if((MEnnemies[b][c][7]>6) & (MEnnemies[b][c][7]<=9)){
				Sprite8(MEnnemies[b][c][1],MEnnemies[b][c][2],8,Mechant13,LCD_MEM,SPRT_XOR);				
			}
			if((MEnnemies[b][c][7]>9) & (MEnnemies[b][c][7]<=12)){
				Sprite8(MEnnemies[b][c][1],MEnnemies[b][c][2],8,Mechant12,LCD_MEM,SPRT_XOR);				
				MEnnemies[b][c][7]=0;
			}
			MEnnemies[b][c][7]++;
		}
		
		if((MEnnemies[b][c][0])&(b==1)){// Mchant qui tire mais se dplace alatoirement
			EMouvRand(b,c,1,2);
			R=random(10);
			if(!R) CreateBullet(1,MEnnemies[b][c][1],MEnnemies[b][c][2],random(5)-2,random(5)-2);

			if(MEnnemies[b][c][7]<=3){
				Sprite8(MEnnemies[b][c][1],MEnnemies[b][c][2],8,Mechant31,LCD_MEM,SPRT_XOR);
			}
			if((MEnnemies[b][c][7]>3) & (MEnnemies[b][c][7]<=6)){
				Sprite8(MEnnemies[b][c][1],MEnnemies[b][c][2],8,Mechant32,LCD_MEM,SPRT_XOR);				
			}
			if((MEnnemies[b][c][7]>6) & (MEnnemies[b][c][7]<=9)){
				Sprite8(MEnnemies[b][c][1],MEnnemies[b][c][2],7,Mechant33,LCD_MEM,SPRT_XOR);				
			}
			if((MEnnemies[b][c][7]>9) & (MEnnemies[b][c][7]<=12)){
				Sprite8(MEnnemies[b][c][1],MEnnemies[b][c][2],8,Mechant32,LCD_MEM,SPRT_XOR);				
				MEnnemies[b][c][7]=0;
			}
			MEnnemies[b][c][7]++;
		}
		
		if((MEnnemies[b][c][0])&(b==2)){// Mchant que l'on doit tuer en plusieurs fois
			EMouvLine(b,c,1,2,3,4,5);
			SpriteAnim2(b,c,MechantBlob1,MechantBlob2,2);
		}

		if((MEnnemies[b][c][0])&(b==3)){// Mchant qui bouge en diagonale
			EMouvDiag(b,c,1,2,3,4,0);
			SpriteAnim2(b,c,MechantDiag1,MechantDiag2,2);
		}
		
		if((MEnnemies[b][c][0])&(b==4)){// Mchant qui bouge en diagonale et qui tire frquemment
			R=random(5);
			if(!R) CreateBullet(2,MEnnemies[b][c][1],MEnnemies[b][c][2],random(5)-2,random(5)-2);
			EMouvDiag(b,c,1,2,3,4,1);	
			SpriteAnim2(b,c,MechantNazi1,MechantNazi2,2);
		}
		
		if((MEnnemies[b][c][0])&(b==5)){// Mchant qui suit le hros comme un chien
			EMouvDogs(b,c,1,2,4);

			SpriteAnim2(b,c,MechantDog1,MechantDog2,2);
		}
	}
	}
}

/////////////////////////////////////////////////////////////////////////
//  				      	Routines de mouvements des ennemis                 //
/////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////
//  					     	Mouvement compltement alatoire                   //
/////////////////////////////////////////////////////////////////////////
void EMouvRand(int type, int num, int Ex, int Ey){

	MEnnemies[type][num][Ex]+=random(11)-5;
	MEnnemies[type][num][Ey]+=random(11)-5;
	if(MEnnemies[type][num][Ex]<0)	MEnnemies[type][num][Ex]=0;
	if(MEnnemies[type][num][Ey]<0)	MEnnemies[type][num][Ey]=0;
	if(MEnnemies[type][num][Ex]>LCD_WIDTH-8)		MEnnemies[type][num][Ex]=LCD_WIDTH-8;
	if(MEnnemies[type][num][Ey]>LCD_HEIGHT-8)		MEnnemies[type][num][Ey]=LCD_HEIGHT-8;
}

/////////////////////////////////////////////////////////////////////////
//  					       	Mouvement linaire diagonal                      //
//     bounce==0, rebondit alatoirement, bounce==1, comme une balle   //
/////////////////////////////////////////////////////////////////////////
void EMouvDiag(int type, int num, int Ex, int Ey, int EVx, int EVy, int bounce){

			MEnnemies[type][num][Ex]+=MEnnemies[type][num][EVx];
			MEnnemies[type][num][Ey]+=MEnnemies[type][num][EVy];
			
	if(!bounce){
			if(MEnnemies[type][num][Ex]<0){
				MEnnemies[type][num][EVx]=random(5)+1;
				MEnnemies[type][num][EVy]=random(11)-4;
			}
			
			if(MEnnemies[type][num][Ey]<0){
				MEnnemies[type][num][EVx]=random(11)-4;
				MEnnemies[type][num][EVy]=random(5)+1;
			}	
			
			if(MEnnemies[type][num][Ex]>LCD_WIDTH-8){
				MEnnemies[type][num][EVx]=-random(5)-1;	
				MEnnemies[type][num][EVy]=random(11)-4;
			} 
			
			if(MEnnemies[type][num][Ey]>LCD_HEIGHT-8){
				MEnnemies[type][num][EVx]=random(11)-4;
				MEnnemies[type][num][EVy]=-random(5)-1;
			} 
	}
	
	if(bounce){
			if((MEnnemies[type][num][Ex]<0) | (MEnnemies[type][num][Ex]>LCD_WIDTH-8))
				MEnnemies[type][num][EVx]=-MEnnemies[type][num][EVx];

			if((MEnnemies[type][num][Ey]<0) | (MEnnemies[type][num][Ey]>LCD_HEIGHT-8))
				MEnnemies[type][num][EVy]=-MEnnemies[type][num][EVy];	
	}
}

/////////////////////////////////////////////////////////////////////////
//          	Mouvement linaire horizontal ou vertical                //
/////////////////////////////////////////////////////////////////////////
void EMouvLine(int type, int num, int Ex, int Ey, int EVx, int EVy, int freq){
	
	MEnnemies[type][num][Ex]+=MEnnemies[type][num][EVx];
	MEnnemies[type][num][Ey]+=MEnnemies[type][num][EVy];
			
	if(MEnnemies[type][num][Ex]<0){
		MEnnemies[type][num][Ex]=0;
		MEnnemies[type][num][EVx]=-MEnnemies[type][num][EVx];
	}
	if(MEnnemies[type][num][Ex]>LCD_WIDTH-8){
		MEnnemies[type][num][Ex]=LCD_WIDTH-8;
		MEnnemies[type][num][EVx]=-MEnnemies[type][num][EVx];
	}
						
	if(MEnnemies[type][num][Ey]<0){
		MEnnemies[type][num][EVy]=-MEnnemies[type][num][EVy];
		MEnnemies[type][num][Ey]=0;		
	}
	if(MEnnemies[type][num][Ey]>LCD_HEIGHT-8){
		MEnnemies[type][num][Ey]=LCD_HEIGHT-8;
		MEnnemies[type][num][EVy]=-MEnnemies[type][num][EVy];
	}	
			
	if(!random(freq)){
		if(MEnnemies[type][num][EVx]){
			MEnnemies[type][num][EVx]=0;
			MEnnemies[type][num][EVy]=random(11)-4;
			if(!MEnnemies[type][num][EVy]) MEnnemies[type][num][EVy]++;
		}
		else{
			MEnnemies[type][num][EVy]=0;
			MEnnemies[type][num][EVx]=random(11)-4;
			if(!MEnnemies[type][num][EVx]) MEnnemies[type][num][EVx]++;
		}
	}

}

/////////////////////////////////////////////////////////////////////////
//               	Mouvement qui se rapproche du hros                  //
/////////////////////////////////////////////////////////////////////////
void EMouvDogs(int type, int num, int Ex, int Ey, int V){
	
	if(MEnnemies[type][num][Ex]<x)
		MEnnemies[type][num][Ex]+=V;

	if(MEnnemies[type][num][Ex]>x)
		MEnnemies[type][num][Ex]-=V;

	if(MEnnemies[type][num][Ey]<y)
		MEnnemies[type][num][Ey]+=V;

	if(MEnnemies[type][num][Ey]>y)
		MEnnemies[type][num][Ey]-=V;

}

/////////////////////////////////////////////////////////////////////////
//                      	Animation des Sprites                        //
/////////////////////////////////////////////////////////////////////////
void SpriteAnim2(int type, int num, unsigned char *img1, unsigned char *img2, int tps){

			if(MEnnemies[type][num][7]==2*tps+1)
				MEnnemies[type][num][7]=1;

			if(MEnnemies[type][num][7]>tps)
				Sprite8(MEnnemies[type][num][1],MEnnemies[type][num][2],8,img1,LCD_MEM,SPRT_XOR);
			else 
				Sprite8(MEnnemies[type][num][1],MEnnemies[type][num][2],8,img2,LCD_MEM,SPRT_XOR);

			MEnnemies[type][num][7]++;

}


/////////////////////////////////////////////////////////////////////////
//  						Tue tous les ennemis sur l'cran (bombe)               //
/////////////////////////////////////////////////////////////////////////
void KillAll(void){
int c;

memset(MEnnemies,0,sizeof(MEnnemies));			// Rempli la matrice des Ennemis de 0
																						// (ne s'affichent donc pas et on peut en crer)

memset(MBullet,0,sizeof(MBullet));					// Rempli la matrice des balles de 0
																						// (ne s'affichent donc pas et on peut en crer)

memcpy(VBackUp,VScrEntities,LCD_SIZE);
FillVScreen(VScrEntities,A_NORMAL);
	if(NbBombs){
	
		for(c=0;c<3;c++){

			WaitForMillis(150);
				LCD_restore(VScrEntities);
			WaitForMillis(150);
				clrscr();

		}

		NbBombs--;
	}
memcpy(VScrEntities,VBackUp,LCD_SIZE);
}

/////////////////////////////////////////////////////////////////////////
//  		Ouverture de la grille quand tous les crystaux sont pris       //
/////////////////////////////////////////////////////////////////////////
int OpenGate(void){
int a;

	if(!opened){
		
		PortSet(VScrEntities,239,127);
			Sprite8((LCD_WIDTH/2)-8,LCD_HEIGHT-8,8,Erase8,VScrEntities,SPRT_AND);
			Sprite8((LCD_WIDTH/2)-8,LCD_HEIGHT-8,8,Erase8,VScrEntities,SPRT_OR);
			Sprite8((LCD_WIDTH/2),LCD_HEIGHT-8,8,Erase8,VScrEntities,SPRT_AND);
			Sprite8((LCD_WIDTH/2),LCD_HEIGHT-8,8,Erase8,VScrEntities,SPRT_OR);
		PortRestore();

		opened=1;
		
	}
	
	if(RectCollisions(x,y,8,8,(LCD_WIDTH/2)-10,LCD_HEIGHT-8,18,10)){
		x=(LCD_WIDTH/2)-4;
		y=LCD_HEIGHT-12;
		PortSet(VScrEntities,239,127);
			for(a=0;a<=8;a++){
				y++;
				WaitForMillis(50);
				DrawScrAct();
			}
		PortRestore();
		
		return 0;
		
	}
	
	return 1;
}


/////////////////////////////////////////////////////////////////////////
//  Interprtation des touches appuyes (lecture par KbdRead())        //
/////////////////////////////////////////////////////////////////////////
void KbdTraduct(void){

		if(!CALCULATOR){
			if(_89_KEY_UP)			Vy-=5;//augmente la vitesse verticale vers le haut
			if(_89_KEY_LEFT)		Vx-=5;//augmente la vitesse horizontale vers la gauche
			if(_89_KEY_DOWN)		Vy+=5;//augmente la vitesse verticale vers le bas
			if(_89_KEY_RIGHT)		Vx+=5;//augmente la vitesse horizontale vers la droite
			if(_89_KEY_2ND)			CreateBullet(0,x+2,y+2,Vx,Vy);
			if(_89_KEY_CLEAR) 	KillAll();//clear ; utilise les bombes
			if(_89_KEY_APPS) 		off();//apps ; teint la calc
			if(_89_KEY_HOME){		end(0); MsgLost="Sortie Force";}//home ; quitte la boucle
			if(_89_KEY_F1) 			GameInfo();//F1 ; pause
		}
		else{
			if(_92P_KEY_UP)			Vy-=5;//augmente la vitesse verticale vers le haut
			if(_92P_KEY_LEFT)		Vx-=5;//augmente la vitesse horizontale vers la gauche
			if(_92P_KEY_DOWN)		Vy+=5;//augmente la vitesse verticale vers le bas
			if(_92P_KEY_RIGHT)	Vx+=5;//augmente la vitesse horizontale vers la droite
			if(_92P_KEY_HAND)		CreateBullet(0,x+2,y+2,Vx,Vy);
			if(_92P_KEY_F1) 		KillAll();//clear ; utilise les bombes
			if(_92P_KEY_APPS) 	off();//apps ; teint la calc
			if(_92P_KEY_ESC){		end(0); MsgLost="Sortie Force";}//esc ; quitte la boucle
			if(_92P_KEY_ENTER1) GameInfo();//F1 ; pause
		}
		
			if(Vx>0)Vx--;
			if(Vx<0)Vx++;
			if(Vy>0)Vy--;
			if(Vy<0)Vy++;
			/* aucune touche n'est enfonce ;
			vrifie si la balle doit avoir une
			inertie, et, dans ce cas, ralentit
			petit  petit la balle */

	x+=Vx;y+=Vy;
	if(x<0)x=0;
	if(y<0)y=0;
	if(x>LCD_WIDTH-8)x=LCD_WIDTH-8;
	if(y>LCD_HEIGHT-8)y=LCD_HEIGHT-8;
	if(Vx>10)Vx=10;
	if(Vy>10)Vy=10;
	if(Vx<-10)Vx=-10;
	if(Vy<-10)Vy=-10;
}


///////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////
////                                                                                       ////
////																	------------------------------											 ////
////                                / |GESTION DE L'AFFICHAGE | /                          ////
////														 ------------------------------    												 ////
////																																											 ////
///////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////
//                      Introduction dans le jeu                        //
//////////////////////////////////////////////////////////////////////////
void intro(void){
clrscr();
FontSetSys(F_8x10);
	DrawStr(30,25,"CrYsTaL",A_NORMAL);
	DrawStr(50,40,"QUEST.",A_NORMAL);
FontSetSys(F_6x8);
	DrawStr(10,60,"By ced38,",A_NORMAL);
	DrawStr(30,70,"ced38@ifrance.com",A_NORMAL);
FontSetSys(F_4x6);
	DrawStr(0,5,"Last Add : ",A_NORMAL);
	DrawStr(0,11,"To do : ",A_NORMAL);
	DrawStr(80,94,"Version BETA n",A_NORMAL);
	DrawStr(34,5,LastAdd,A_NORMAL);
	DrawStr(24,11,Todo,A_NORMAL);
	DrawStr(136,94,Version,A_NORMAL);
	if(!CALCULATOR){
		WAITKEYPRESSED(_89_KEY_ENTER);
	} 
	else{
		WAITKEYPRESSED(_92P_KEY_ENTER1);
	}

}

/////////////////////////////////////////////////
//           Animation des sprites             //
/////////////////////////////////////////////////
void SpriteAnim(void){

}

/////////////////////////////////////////////////
// Affichage final (ce que vois l'utilisateur) //
/////////////////////////////////////////////////
void DrawScrAct(void){
	LCD_restore(VScrEntities);							//-> Affiche l'cran virtuel VScrEntities (cran des
																					// objets tels que : Mines, Bombes, crystaux, portails)

	DrawEnnemies();													//-> Dessine les ennemis (sur l'cran principal)

	DrawBullets();													//-> Dessine les balles et ralentit l'affichage grce
																					//  une boucle vide de 1000
}

////////////////////////////////////////////////////////////////////////////
// Dsactivation des crans virtuels, nv de gris, etc., pour ne pas avoir //
// d'erreurs en revenant sur le TI-OS                                     //
////////////////////////////////////////////////////////////////////////////
void FillWithZeros(void){

	memset(MBullet,0,sizeof(MBullet));						// Rempli la matrice des balles de 0 (elles
																								// s'affichent donc pas et on peut en crer)

	memset(MEntities,0,sizeof(MEntities));				// Rempli la matrice des Mines et crystaux de 0
																								// (ne s'affichent donc pas et on peut en crer)

	memset(MEnnemies,0,sizeof(MEnnemies));				// Rempli la matrice des Ennemis de 0
																								// (ne s'affichent donc pas et on peut en crer)																								

  memset(VScrEntities,0,LCD_SIZE);   						// On libre l'espace mmoire qui avait t 
  																							// allou pour l'cran virtuel VScrEntities.

  memset(VBackUp,0,LCD_SIZE);   								// On libre l'espace mmoire qui avait t 
 																								// allou pour l'cran virtuel VBackUp.

  memset(LCD_MEM,0,LCD_SIZE);   								// Rinitialise l'cran.
  																							
}



///////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////

void end(int error){
	PortRestore();
	clrscr();
	FontSetSys(F_8x10);
	printf_xy(30,20,"GAME OVER !");
	FontSetSys(F_4x6);
	printf_xy(5,60,"Remerciements : Kevin (aka Ze boss),");
	printf_xy(20,68,"la Tigcc team, Rusty Wagner (VTI), ");
	printf_xy(20,76,"et tous ceux de ti-fr ;-)...");
	printf_xy(20,86,MsgLost);
	printf_xy(92,94,"ced38@ifrance.com");
	if(!CALCULATOR){
		WAITKEYPRESSED(_89_KEY_ENTER);
	} 
	else{
		WAITKEYPRESSED(_92P_KEY_ENTER1);
	}

	FillWithZeros();					// Rempli les matrices de Zros (par ex., efface les crans virtuels)
	free(VScrEntities);				// Libre l'cran virtuel
	free(VBackUp);				// Libre l'cran virtuel
	Reenable_int();						// Fonction de crystal_IO.h
	exit(error);
}

// Main Function
void _main(void)
{
Disable_int();						// Fonction de crystal_IO.h

x=(LCD_WIDTH/2)-4; 
y=(LCD_HEIGHT/2)-4;				//===========================================//						
Vx=0, Vy=0;								// Donne les valeurs initiales des variables //
opened=0; 	  						//===========================================//
LastAdd="EXIT BUG CORRECTED";
Todo="Graphic interface";
Version="0.65";


OldTime=0;
Time=0;
level=1;
NbCrystals=0;
NbMines=0;
NbBombs=3;
NbLives=3;
Score[0]=NbLives;
Score[1]=0;
EnnemyTimer=0;
NumEnnemies=1;

VScrEntities=malloc(LCD_SIZE); // On alloue un espace de la taille de l'cran  l'cran virtuel
VBackUp=malloc(LCD_SIZE); // On alloue un espace de la taille de l'cran  l'cran virtuel

intro();

RunLevel();

}
